﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Data;
using System.Data.SqlClient;
using System.Reflection;
using System.Text;
namespace wijgridsample.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            // TempData["data"]=ConvertDataTableTojSonString(GetDataset().Tables[0]);
            return View();
        }

        //private DataSet GetDataset()
        //{
        //    DataSet ds = new DataSet();
        //    string connectionString = System.Configuration.ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString;
        //    using (SqlConnection connection = new SqlConnection(connectionString))
        //    {
        //        connection.Open();

        //        using (SqlCommand command = new SqlCommand(
        //        "SELECT  * FROM [dbo].[OWL_Clients]  ",
        //        connection))
        //        {
        //            SqlDataAdapter da = new SqlDataAdapter();
        //            da.SelectCommand = command;

        //            da.Fill(ds);
        //            connection.Close();
        //        }
        //    }
        //    return ds;
        //}

        private DataTable GetDateTimeTable()
        {
            DataTable dataTable = new DataTable();
            dataTable.Columns.AddRange(new DataColumn[3] { new DataColumn("Id", typeof(int)),
                            new DataColumn("File Name", typeof(string)),
                            new DataColumn("Uploaded On",typeof(DateTime)) });
            dataTable.Rows.Add(1, "Flowers", "2016-08-30 07:28:10.900");
            dataTable.Rows.Add(2, "Fruits", "2016-08-30 09:27:19.493");
            return dataTable;
        }

        public JsonResult ClientsList()
        {
       
         /// return Json(ConvertDataTableTojSonString(GetDataset().Tables[0]), JsonRequestBehavior.AllowGet);
            return Json(ConvertDataTableTojSonString(GetDateTimeTable()), JsonRequestBehavior.AllowGet);
        }
 
        public static string ConvertDataTableTojSonString(DataTable dataTable)
        {
            System.Web.Script.Serialization.JavaScriptSerializer serializer =
                   new System.Web.Script.Serialization.JavaScriptSerializer();
            serializer.MaxJsonLength = int.MaxValue;
            List<Dictionary<String, Object>> tableRows = new List<Dictionary<String, Object>>();

            Dictionary<String, Object> row;

            foreach (DataRow dr in dataTable.Rows)
            {
                row = new Dictionary<String, Object>();
                foreach (DataColumn col in dataTable.Columns)
                {
                    row.Add(col.ColumnName, dr[col]);
                }
                tableRows.Add(row);
            }
            return serializer.Serialize(tableRows);
        }

        public class WijmoGridResult
        {
            List<dynamic> _jsonItems;
            public List<dynamic> JsonItems
            {
                get
                {
                    return _jsonItems;
                }
                set
                {
                    _jsonItems = value;
                }
            }

            //public dynamic SelectedItem { get; set; }

            public int TotalRowCount { get; set; }
        }
        #region Convert Dataset to List
        public static List<T> ConvertDataTableToList<T>(DataTable dt)
        {
            List<T> data = new List<T>();
            foreach (DataRow row in dt.Rows)
            {
                T item = GetItem<T>(row);
                data.Add(item);
            }
            return data;
        }
        public static T GetItem<T>(DataRow dr)
        {
            Type temp = typeof(T);
            T obj = Activator.CreateInstance<T>();

            foreach (DataColumn column in dr.Table.Columns)
            {
                foreach (PropertyInfo pro in temp.GetProperties())
                {
                    if (pro.Name == column.ColumnName)
                    {
                        var value = (dr[column.ColumnName] == DBNull.Value) ?
                   null : (dr[column.ColumnName]); //if database field is nullable
                        pro.SetValue(obj, value, null);

                    }
                    else
                        continue;
                }
            }
            return obj;
        }
        #endregion

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}